=== debian/changelog ===
yoshimi (1.4.0.1-1build1) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:12:44 +0000

yoshimi (1.4.0.1-1) unstable; urgency=medium

  * Imported Upstream version 1.4.0.1
  * Update description.
  * Bump Standards.
  * Patch refreshed.
  * Fix hardening.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 16 Jun 2016 00:43:48 +0200

yoshimi (1.3.9-1) unstable; urgency=medium

  * New upstream release.
    - Fix build issues with GCC 6 (Closes: 814011)
  * debian/patches/manpage-fixes.patch: Removed, applied upstream.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 29 Feb 2016 00:38:57 +0100
