## yoshimi 1.5.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,14 @@
 endif (POLICY CMP0046)
 set (CMAKE_CXX_STANDARD 11) # we seem to need both for
 add_definitions(-std=gnu++11) # various versions of cmake
-set (YOSHIMI_VERSION "1.4.0.1")
+
+add_definitions(-Wall)
+add_definitions(-Werror=format-security)
+
+# ^^^ comment these two out on release pushes ^^^
+
+set (YOSHIMI_VERSION "1.5.0")
+
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -67,6 +74,10 @@
 option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
 option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
 option (BuildForDebug "Include gdb debugging support" OFF)
+
+option (EnableGuiReports "Enable GUI control reports" OFF)
+
+option (ReportNoteOnTimes "Report Note-On Times" OFF)
 
 #option to build lv2 plugin
 option (BuildLV2Plugin "Build yoshimi lv2 plugin interface" ON)
@@ -187,18 +198,14 @@
 mark_as_advanced (FLTK_MATH_LIBRARY)
 
 
-# libncurses
-pkg_check_modules (LIBNCURSES ncurses)
-if (LIBNCURSES_FOUND)
-    message (STATUS "Found libncurses ${LIBNCURSES_VERSION}")
-else ()
-    pkg_check_modules (LIBNCURSES REQUIRED ncursesw)
-    if (LIBNCURSES_FOUND)
-        message (STATUS "Found libncursesw ${LIBNCURSES_VERSION}")
-    else()
-        message (FATAL_ERROR "libncurses required but not found")
-    endif ()
-endif ()
+# libncurses / libcursesw
+set(CURSES_NEED_NCURSES TRUE)
+find_package (Curses REQUIRED)
+if (CURSES_FOUND)
+    message(STATUS "Found libncurses or libncursesw")
+else (CURSES_FOUND)
+    message(FATAL_ERROR "libncurses or libncursesw required but not found")
+endif (CURSES_FOUND)
 
 find_path(Readline_ROOT_DIR
     NAMES include/readline/readline.h
@@ -214,14 +221,15 @@
     HINTS ${Readline_ROOT_DIR}/lib
 )
 
-if(Readline_INCLUDE_DIR AND Readline_LIBRARY AND Ncurses_LIBRARY)
+#find_package(PkgConfig REQUIRED)
+if(Readline_INCLUDE_DIR AND Readline_LIBRARY AND CURSES_LIBRARY)
   set(READLINE_FOUND TRUE)
-else(Readline_INCLUDE_DIR AND Readline_LIBRARY AND Ncurses_LIBRARY)
+else(Readline_INCLUDE_DIR AND Readline_LIBRARY AND CURSES_LIBRARY)
   FIND_LIBRARY(Readline_LIBRARY NAMES readline)
   include(FindPackageHandleStandardArgs)
   FIND_PACKAGE_HANDLE_STANDARD_ARGS(Readline DEFAULT_MSG Readline_INCLUDE_DIR Readline_LIBRARY )
   MARK_AS_ADVANCED(Readline_INCLUDE_DIR Readline_LIBRARY)
-endif(Readline_INCLUDE_DIR AND Readline_LIBRARY AND Ncurses_LIBRARY)
+endif(Readline_INCLUDE_DIR AND Readline_LIBRARY AND CURSES_LIBRARY)
 
 mark_as_advanced(
     Readline_ROOT_DIR
@@ -273,8 +281,15 @@
 )
 
 set (Misc_sources
-    Misc/ConfBuild.cpp  Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp
-    Misc/Microtonal.cpp   Misc/Part.cpp  Misc/XMLwrapper.cpp  Misc/MiscFuncs.cpp   Misc/WavFile.cpp   Misc/CmdInterface.cpp
+    Misc/ConfBuild.cpp  Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp  Misc/Splash.cpp
+    Misc/Microtonal.cpp   Misc/Part.cpp  Misc/XMLwrapper.cpp  Misc/MiscFuncs.cpp   Misc/WavFile.cpp
+)
+
+set (Interface_Sources
+    Interface/CmdInterface.cpp
+    Interface/InterChange.cpp
+    Interface/MidiLearn.cpp
+    UI/MiscGui.cpp
 )
 
 set (Params_sources
@@ -296,14 +311,14 @@
 )
 
 set (FltkUI_names
-    "WidgetPDialUI"  "PresetsUI"  "EnvelopeUI"
-    "LFOUI"  "FilterUI"  "VirKeyboardUI"
-    "ConfigUI"  "SUBnoteUI"  "ResonanceUI"
-    "OscilGenUI"  "ADnoteUI"  "PADnoteUI"
-    "EffUI"  "BankUI"  "PartUI"
-    "MicrotonalUI"  "MasterUI" "MasterMiscUI"
+    "WidgetPDialUI" "PresetsUI" "EnvelopeUI"
+    "LFOUI" "FilterUI" "VirKeyboardUI"
+    "ConfigUI" "SUBnoteUI" "ResonanceUI"
+    "OscilGenUI" "ADnoteUI" "PADnoteUI"
+    "EffUI" "BankUI" "PartUI"
+    "MicrotonalUI" "MasterUI" "MasterMiscUI"
     "ParametersUI" "ConsoleUI" "VectorUI"
-    "WidgetMWSliderUI" "WidgetMWRollerUI"
+    "MidiLearnUI" "WidgetMWSliderUI"
 )
 
 # workaround fltk_wrap_ui breakage
@@ -346,6 +361,7 @@
 add_definitions (-DPAD_COLOUR=0xcfdfaf00)
 add_definitions (-DNUM_MIDI_PARTS=64)
 add_definitions (-DNUM_MIDI_CHANNELS=16)
+add_definitions (-DMIDI_LEARN_BLOCK=128)
 add_definitions (-DMAX_ENVELOPE_POINTS=40)
 add_definitions (-DMIN_ENVELOPE_DB=-60)
 add_definitions (-DMAX_RESONANCE_POINTS=256)
@@ -361,12 +377,3 @@
 add_definitions (-DXML_INSTRUMENT=1)
 add_definitions (-DXML_PARAMETERS=2)
 add_definitions (-DXML_MICROTONAL=3)
-add_definitions (-DXML_PRESETS=4)
-add_definitions (-DXML_STATE=5)
-add_definitions (-DXML_CONFIG=6)
-add_definitions (-DXML_BANK=7)
-add_definitions (-DXML_HISTORY=8)
-add_definitions (-DXML_VECTOR=9)
-
-# these were previously (pointlessly) user configurable
-add_definitions (-DNUM_VOICES=8)
