=== debian/changelog ===
yoshimi (1.5.0-3) unstable; urgency=medium

  * Update copyright file.
  * Add patch to update appdata file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 16 Jan 2017 10:06:53 +0100

yoshimi (1.5.0-2) unstable; urgency=medium

  * Install LV2 plugins. (Closes: 849166)
    Thanks to Takeshi Soejima <sohet@mbox.kyoto-inet.or.jp>
  * Add lintian-overrides file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 23 Dec 2016 10:20:53 +0100

yoshimi (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 18 Dec 2016 00:27:35 +0100

yoshimi (1.4.1-2) unstable; urgency=medium

  * Fix patch description.
  * Set dh/compat 10.
  * Remove redundant amd64 flags.
  * Sign tags.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 13 Dec 2016 17:23:46 +0100

yoshimi (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1
  * Patch refreshed.
  * Add spelling patch.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 05 Sep 2016 21:19:53 +0200
