## yoshimi 1.5.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #   CMakeLists.txt
 #
 #   Copyright 2009-2011, Alan Calvert
-#   Copyright 2014-2016, Will Godfrey, and others
+#   Copyright 2014-2017, Will Godfrey & others
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -27,12 +27,12 @@
 set (CMAKE_CXX_STANDARD 11) # we seem to need both for
 add_definitions(-std=gnu++11) # various versions of cmake
 
-add_definitions(-Wall)
-add_definitions(-Werror=format-security)
+#add_definitions(-Wall)
+#add_definitions(-Werror=format-security)
 
 # ^^^ comment these two out on release pushes ^^^
 
-set (YOSHIMI_VERSION "1.5.0")
+set (YOSHIMI_VERSION "1.5.3")
 
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
@@ -68,21 +68,18 @@
     set (JackSessionSupport OFF)
 endif (HasJackSession)
 
-#set (DefaultAudio jack CACHE STRING "Default audio driver - alsa or jack")
-#set (DefaultMidi jack CACHE STRING "Default midi driver - alsa or jack")
-
 option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
 option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
+option (BuildForNEON "Build for ARM Cortex A9 system" OFF)
+option (BuildForThisCPU "Build for presently running system" OFF)
 option (BuildForDebug "Include gdb debugging support" OFF)
 
-option (EnableGuiReports "Enable GUI control reports" OFF)
-
-option (ReportNoteOnTimes "Report Note-On Times" OFF)
-
 #option to build lv2 plugin
-option (BuildLV2Plugin "Build yoshimi lv2 plugin interface" ON)
-
-set (FifoDirectory /dev/shm CACHE STRING "Directory for fifos")
+option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)
+
+# developer info
+option (ShowGuiReports "Enable GUI control reports" OFF)
+option (ShowNoteOnTimes "Report Note-On Times" OFF)
 
 set (BuildOptions_x86_64AMD
     "-O3 -march=athlon64 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
@@ -92,6 +89,16 @@
 set (BuildOptions_X86_64Core2
     "-O3 -march=core2 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
   CACHE STRING "X86_64 compiler options"
+)
+
+set (BuildOptions_NEON
+"-O3 -march=armv7-a -mfloat-abi=hard -mfpu=neon -mcpu=cortex-a9 -mtune=cortex-a9 -pipe -mvectorize-with-neon-quad -funsafe-loop-optimizations"
+  CACHE STRING "Cortex_a9 compiler options"
+)
+
+set (BuildOptionsThisCPU
+    "-O3 -march=native -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
+  CACHE STRING "Current CPU compiler options"
 )
 
 set (BuildOptionsBasic
@@ -257,7 +264,16 @@
         if (BuildForCore2_X86_64)
             set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64Core2})
         else (BuildForCore2_X86_64)
-            set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
+            if (BuildForNEON)
+                set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_NEON})
+            else (BuildForNEON)
+                set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
+                if (BuildForThisCPU)
+                    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsThisCPU})
+                else (BuildForThicCPU)
+                    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
+                endif (BuildForThisCPU)
+            endif (BuildForNEON)
         endif (BuildForCore2_X86_64)
     endif (BuildForAMD_X86_64)
     message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
@@ -289,6 +305,7 @@
     Interface/CmdInterface.cpp
     Interface/InterChange.cpp
     Interface/MidiLearn.cpp
+    Interface/MidiDecode.cpp
     UI/MiscGui.cpp
 )
 
@@ -311,14 +328,14 @@
 )
 
 set (FltkUI_names
-    "WidgetPDialUI" "PresetsUI" "EnvelopeUI"
+    "PresetsUI" "EnvelopeUI"
     "LFOUI" "FilterUI" "VirKeyboardUI"
     "ConfigUI" "SUBnoteUI" "ResonanceUI"
     "OscilGenUI" "ADnoteUI" "PADnoteUI"
     "EffUI" "BankUI" "PartUI"
     "MicrotonalUI" "MasterUI" "MasterMiscUI"
     "ParametersUI" "ConsoleUI" "VectorUI"
-    "MidiLearnUI" "WidgetMWSliderUI"
+    "MidiLearnUI"
 )
 
 # workaround fltk_wrap_ui breakage
@@ -337,6 +354,13 @@
     set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
 endforeach(basename ${FltkUI_names})
 
+set (FltkUI_sources
+    ${FltkUI_sources}
+    UI/DynamicTooltip.cpp
+    UI/WidgetPDial.cpp
+    UI/WidgetMWSlider.cpp
+)
+
 add_definitions (
     -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
     -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'
@@ -345,35 +369,11 @@
     -DYOSHI_FIFO_DIR="${FifoDirectory}"
 )
 
+# many of these are here for convenience and consistency
+# changing them is likely to have unpredicable consequences
 add_definitions (-DYOSHIMI="yoshimi")
 add_definitions (-DCOMMAND_SIZE=80)
 add_definitions (-DMAX_HISTORY=25)
 add_definitions (-DMAX_PRESETS=1000)
 add_definitions (-DMAX_PRESET_DIRS=128)
 add_definitions (-DMAX_BANK_ROOT_DIRS=128)
-add_definitions (-DMAX_BANKS_IN_ROOT=128)
-add_definitions (-DMAX_AD_HARMONICS=128)
-add_definitions (-DMAX_SUB_HARMONICS=64)
-add_definitions (-DPAD_MAX_SAMPLES=96)
-add_definitions (-DADD_COLOUR=0xdfafbf00)
-add_definitions (-DBASE_COLOUR=0xbfbfbf00)
-add_definitions (-DSUB_COLOUR=0xafcfdf00)
-add_definitions (-DPAD_COLOUR=0xcfdfaf00)
-add_definitions (-DNUM_MIDI_PARTS=64)
-add_definitions (-DNUM_MIDI_CHANNELS=16)
-add_definitions (-DMIDI_LEARN_BLOCK=128)
-add_definitions (-DMAX_ENVELOPE_POINTS=40)
-add_definitions (-DMIN_ENVELOPE_DB=-60)
-add_definitions (-DMAX_RESONANCE_POINTS=256)
-add_definitions (-DMAX_KEY_SHIFT=36)
-add_definitions (-DMIN_KEY_SHIFT=-36)
-
-add_definitions (-DPI=3.1415926536f)
-add_definitions (-DTWOPI=6.28318530718f)
-add_definitions (-DHALFPI=1.57079632679f)
-add_definitions (-DLOG_2=0.693147181f)
-
-#probably not the best way to do this :(
-add_definitions (-DXML_INSTRUMENT=1)
-add_definitions (-DXML_PARAMETERS=2)
-add_definitions (-DXML_MICROTONAL=3)
