=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,7 @@
     ../Misc/SynthEngine.h  ../Misc/Bank.h  ../Misc/Microtonal.h
     ../Misc/Part.h  ../Misc/XMLwrapper.h  ../Misc/MiscFuncs.h ../Misc/WavFile.h)
 file (GLOB yoshimi_interface_files
+    ../Interface/MidiDecode.cpp ../Interface/MidiDecode.h
     ../Interface/InterChange.cpp ../Interface/InterChange.h
     ../Interface/MidiLearn.cpp ../Interface/MidiLearn.h
     ../UI/MiscGui.cpp ../UI/MiscGui.h)
@@ -69,14 +70,14 @@
     yoshimi.ttl)
 
 set (FltkUI_names
-    "WidgetPDialUI"  "PresetsUI"  "EnvelopeUI"
+    "PresetsUI"  "EnvelopeUI"
     "LFOUI"  "FilterUI"  "VirKeyboardUI"
     "ConfigUI"  "SUBnoteUI"  "ResonanceUI"
     "OscilGenUI"  "ADnoteUI"  "PADnoteUI"
     "EffUI"  "BankUI"  "PartUI"
     "MicrotonalUI"  "MasterUI" "MasterMiscUI"
     "ParametersUI" "ConsoleUI" "VectorUI"
-    "MidiLearnUI" "WidgetMWSliderUI"
+    "MidiLearnUI"
 )
 
 # workaround fltk_wrap_ui breakage
@@ -95,6 +96,12 @@
     set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
 endforeach(basename ${FltkUI_names})
 
+set (FltkUI_sources
+    ${FltkUI_sources}
+    ../UI/DynamicTooltip.cpp
+    ../UI/WidgetPDial.cpp
+    ../UI/WidgetMWSlider.cpp
+)
 
 add_definitions (-DYOSHIMI_LV2_PLUGIN=1)
