=== debian/changelog ===
yoshimi (1.5.3-1) unstable; urgency=medium

  * New upstream version 1.5.3
  * Bump Standards.
  * Update Vcs - use git instead of cgit.
  * Introduce postclone.sh script to ignore .pc/ dir.
  * Update install file.
  * Update override file.
  * Add spelling patch.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 22 Aug 2017 12:21:46 +0200

yoshimi (1.5.2.1-1) unstable; urgency=medium

  * New upstream version 1.5.2.1
  * Patches deleted/refreshed.
  * Bump Standards.
  * Update override file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 25 Jun 2017 19:50:31 +0200
