=== debian/control ===
--- 
+++ 
@@ -25,9 +25,9 @@
  lv2-dev,
  sharutils,
  zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/yoshimi.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/yoshimi.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/yoshimi.git
 Homepage: http://yoshimi.sourceforge.net
 
 Package: yoshimi
